/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servlet;

import bdd.GardeMySQL;

import bean.Gardes;
import bean.Pompier;
import form.DispoForm;
import util.TrmtDate;
import java.io.IOException;
import java.io.PrintWriter;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.Calendar;

/**
 *
 * @author funcha.ahamadi
 */
public class GardesServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try ( PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet feuilleGardes</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet feuilleGardes at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
        HttpSession maSession = request.getSession();
        
         if(maSession.getAttribute("lesVentilInit") == null){
        ArrayList<Pompier> lesPompiers = (ArrayList<Pompier>) maSession.getAttribute("lesPompiers");
        Calendar[] lesDates = new Calendar[7];
        String[] lesDatesEnString = new String[7];
        lesDates[0] = TrmtDate.getDateDebutSemaine();
        lesDatesEnString[0] = TrmtDate.getDateAAfficher(lesDates[0]);
        
        for (int i = 1; i < lesDates.length; i++) {
            lesDates[i] = TrmtDate.addDays(lesDates[0], i);
            lesDatesEnString[i] = TrmtDate.getDateAAfficher(lesDates[i]);
        }
        maSession.setAttribute("lesDates", lesDates);
        
        maSession.setAttribute("lesDatesEnString", lesDatesEnString);
             System.out.println(lesDatesEnString.toString());
        /*Initialisation des periodes */
        int[] lesPeriodes = {1,2,3,4};
        maSession.setAttribute("lesPeriodes", lesPeriodes);
        System.out.println(lesPeriodes.toString());
        /* Recherche des ventilations */
        
            GardeMySQL vm = new GardeMySQL();
            ArrayList<Gardes> lesVentilInit = vm.getLesDisponibilite(lesDates, lesPeriodes,request);
            //System.out.println("lesVentilInit : " + lesVentilInit);
            maSession.setAttribute("lesVentilInit", lesVentilInit);
            
            
            /* Initialisation des couleurs */
            String[] lesCouleurs = {"blanc", "gris", "jaune"};
            maSession.setAttribute("lesCouleurs", lesCouleurs);
         }
         /* Affichage de la page de ventilation */
        getServletContext().getRequestDispatcher("/WEB-INF/feuilleGardes.jsp").forward(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
//        processRequest(request, response);
            DispoForm vf = new DispoForm();
        vf.verifDispo(request);
        getServletContext().getRequestDispatcher("/WEB-INF/pompierJSP.jsp").forward(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
